#include <field.h>
#include "parser.h"

void parseData(KexiDB::Parser *p, const char *data);
#define PERCENT 257
#define SQL_TYPE 258
#define SQL_ABS 259
#define ACOS 260
#define AMPERSAND 261
#define SQL_ABSOLUTE 262
#define ADA 263
#define ADD 264
#define ADD_DAYS 265
#define ADD_HOURS 266
#define ADD_MINUTES 267
#define ADD_MONTHS 268
#define ADD_SECONDS 269
#define ADD_YEARS 270
#define ALL 271
#define ALLOCATE 272
#define ALTER 273
#define AND 274
#define ANY 275
#define ARE 276
#define ARITHMETIC_MINUS 277
#define ARITHMETIC_PLUS 278
#define AS 279
#define ASIN 280
#define ASC 281
#define ASCII 282
#define ASSERTION 283
#define ASTERISK 284
#define AT 285
#define ATAN 286
#define ATAN2 287
#define AUTHORIZATION 288
#define AUTO_INCREMENT 289
#define AVG 290
#define BEFORE 291
#define SQL_BEGIN 292
#define BETWEEN 293
#define BIGINT 294
#define BINARY 295
#define BIT 296
#define BIT_LENGTH 297
#define BREAK 298
#define BY 299
#define CASCADE 300
#define CASCADED 301
#define CASE 302
#define CAST 303
#define CATALOG 304
#define CEILING 305
#define CENTER 306
#define SQL_CHAR 307
#define CHAR_LENGTH 308
#define CHARACTER_STRING_LITERAL 309
#define CHECK 310
#define CLOSE 311
#define COALESCE 312
#define COBOL 313
#define COLLATE 314
#define COLLATION 315
#define COLON 316
#define COLUMN 317
#define COMMA 318
#define COMMIT 319
#define COMPUTE 320
#define CONCAT 321
#define CONNECT 322
#define CONNECTION 323
#define CONSTRAINT 324
#define CONSTRAINTS 325
#define CONTINUE 326
#define CONVERT 327
#define CORRESPONDING 328
#define COS 329
#define COT 330
#define COUNT 331
#define CREATE 332
#define CURDATE 333
#define CURRENT 334
#define CURRENT_DATE 335
#define CURRENT_TIME 336
#define CURRENT_TIMESTAMP 337
#define CURTIME 338
#define CURSOR 339
#define DATABASE 340
#define SQL_DATE 341
#define DATE_FORMAT 342
#define DATE_REMAINDER 343
#define DATE_VALUE 344
#define DAY 345
#define DAYOFMONTH 346
#define DAYOFWEEK 347
#define DAYOFYEAR 348
#define DAYS_BETWEEN 349
#define DEALLOCATE 350
#define DEC 351
#define DECLARE 352
#define DEFAULT 353
#define DEFERRABLE 354
#define DEFERRED 355
#define SQL_DELETE 356
#define DESC 357
#define DESCRIBE 358
#define DESCRIPTOR 359
#define DIAGNOSTICS 360
#define DICTIONARY 361
#define DIRECTORY 362
#define DISCONNECT 363
#define DISPLACEMENT 364
#define DISTINCT 365
#define DOLLAR_SIGN 366
#define DOMAIN_TOKEN 367
#define DOT 368
#define SQL_DOUBLE 369
#define DOUBLE_QUOTED_STRING 370
#define DROP 371
#define ELSE 372
#define END 373
#define END_EXEC 374
#define EQUAL 375
#define ESCAPE 376
#define EXCEPT 377
#define SQL_EXCEPTION 378
#define EXEC 379
#define EXECUTE 380
#define EXISTS 381
#define EXP 382
#define EXPONENT 383
#define EXTERNAL 384
#define EXTRACT 385
#define SQL_FALSE 386
#define FETCH 387
#define FIRST 388
#define SQL_FLOAT 389
#define FLOOR 390
#define FN 391
#define FOR 392
#define FOREIGN 393
#define FORTRAN 394
#define FOUND 395
#define FOUR_DIGITS 396
#define FROM 397
#define FULL 398
#define GET 399
#define GLOBAL 400
#define GO 401
#define GOTO 402
#define GRANT 403
#define GREATER_THAN 404
#define GREATER_OR_EQUAL 405
#define GROUP 406
#define HAVING 407
#define HOUR 408
#define HOURS_BETWEEN 409
#define IDENTITY 410
#define IFNULL 411
#define SQL_IGNORE 412
#define IMMEDIATE 413
#define SQL_IN 414
#define INCLUDE 415
#define INDEX 416
#define INDICATOR 417
#define INITIALLY 418
#define INNER 419
#define INPUT 420
#define INSENSITIVE 421
#define INSERT 422
#define INTEGER 423
#define INTERSECT 424
#define INTERVAL 425
#define INTO 426
#define IS 427
#define ISOLATION 428
#define JOIN 429
#define JUSTIFY 430
#define KEY 431
#define LANGUAGE 432
#define LAST 433
#define LCASE 434
#define LEFT 435
#define LEFTPAREN 436
#define LENGTH 437
#define LESS_OR_EQUAL 438
#define LESS_THAN 439
#define LEVEL 440
#define LIKE 441
#define LINE_WIDTH 442
#define LOCAL 443
#define LOCATE 444
#define LOG 445
#define SQL_LONG 446
#define LOWER 447
#define LTRIM 448
#define LTRIP 449
#define MATCH 450
#define SQL_MAX 451
#define MICROSOFT 452
#define SQL_MIN 453
#define MINUS 454
#define MINUTE 455
#define MINUTES_BETWEEN 456
#define MOD 457
#define MODIFY 458
#define MODULE 459
#define MONTH 460
#define MONTHS_BETWEEN 461
#define MUMPS 462
#define NAMES 463
#define NATIONAL 464
#define NCHAR 465
#define NEXT 466
#define NODUP 467
#define NONE 468
#define NOT 469
#define NOT_EQUAL 470
#define NOW 471
#define SQL_NULL 472
#define NULLIF 473
#define NUMERIC 474
#define OCTET_LENGTH 475
#define ODBC 476
#define OF 477
#define SQL_OFF 478
#define SQL_ON 479
#define ONLY 480
#define OPEN 481
#define OPTION 482
#define OR 483
#define ORDER 484
#define OUTER 485
#define OUTPUT 486
#define OVERLAPS 487
#define PAGE 488
#define PARTIAL 489
#define SQL_PASCAL 490
#define PERSISTENT 491
#define CQL_PI 492
#define PLI 493
#define POSITION 494
#define PRECISION 495
#define PREPARE 496
#define PRESERVE 497
#define PRIMARY 498
#define PRIOR 499
#define PRIVILEGES 500
#define PROCEDURE 501
#define PRODUCT 502
#define PUBLIC 503
#define QUARTER 504
#define QUESTION_MARK 505
#define QUIT 506
#define RAND 507
#define READ_ONLY 508
#define REAL 509
#define REFERENCES 510
#define REPEAT 511
#define REPLACE 512
#define RESTRICT 513
#define REVOKE 514
#define RIGHT 515
#define RIGHTPAREN 516
#define ROLLBACK 517
#define ROWS 518
#define RPAD 519
#define RTRIM 520
#define SCHEMA 521
#define SCREEN_WIDTH 522
#define SCROLL 523
#define SECOND 524
#define SECONDS_BETWEEN 525
#define SELECT 526
#define SEMICOLON 527
#define SEQUENCE 528
#define SETOPT 529
#define SET 530
#define SHOWOPT 531
#define SIGN 532
#define SIGNED_INTEGER 533
#define SIN 534
#define SINGLE_QUOTE 535
#define SQL_SIZE 536
#define SLASH 537
#define SMALLINT 538
#define SOME 539
#define SPACE 540
#define SQL 541
#define SQL_TRUE 542
#define SQLCA 543
#define SQLCODE 544
#define SQLERROR 545
#define SQLSTATE 546
#define SQLWARNING 547
#define SQRT 548
#define STDEV 549
#define SUBSTRING 550
#define SUM 551
#define SYSDATE 552
#define SYSDATE_FORMAT 553
#define SYSTEM 554
#define TABLE 555
#define TAN 556
#define TEMPORARY 557
#define THEN 558
#define THREE_DIGITS 559
#define TIME 560
#define TIMESTAMP 561
#define TIMEZONE_HOUR 562
#define TIMEZONE_MINUTE 563
#define TINYINT 564
#define TO 565
#define TO_CHAR 566
#define TO_DATE 567
#define TRANSACTION 568
#define TRANSLATE 569
#define TRANSLATION 570
#define TRUNCATE 571
#define GENERAL_TITLE 572
#define TWO_DIGITS 573
#define UCASE 574
#define UNION 575
#define UNIQUE 576
#define SQL_UNKNOWN 577
#define UNSIGNED_INTEGER 578
#define UPDATE 579
#define UPPER 580
#define USAGE 581
#define USER 582
#define USER_DEFINED_NAME 583
#define USING 584
#define VALUE 585
#define VALUES 586
#define VARBINARY 587
#define VARCHAR 588
#define VARYING 589
#define VENDOR 590
#define VIEW 591
#define WEEK 592
#define WHEN 593
#define WHENEVER 594
#define WHERE 595
#define WHERE_CURRENT_OF 596
#define WITH 597
#define WORD_WRAPPED 598
#define WORK 599
#define WRAPPED 600
#define YEAR 601
#define YEARS_BETWEEN 602
typedef union {
	char stringValue[255];
	int integerValue;
	KexiDB::Field::Type coltype;
	KexiDB::Field *field;
} YYSTYPE;
extern YYSTYPE yylval;
